//
//  InputNeuron.h
//  Neuron1
//
//  Created by Leslie Smith on Sat Jun 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

#define MAXPOSTSYNAPSES 25

@interface InputNeuron : NSObject {
	int output ; /* normally 0, 1 for one time step */
	float timestep ; /* default timestep in seconds */

	NSMutableArray * PostSynaptic ; // array of synapses innervated by this neuron
}

- init ;
- (void) dealloc  ;
- (int) isInputNeuron ;
- setTimeStep: (float) stepsize; /* set timestep */
- (float) getTimeStep ; /* returns timestep in use last time step */
- (int) getOutput ; /* returns output */
- addTarget: Syn ; // add a synapse to the set that this neuron innervates (is presynaptic)
- fire: (double) actime: (int) stepno ; // action on firing (internal only)
- resetNeuron ;
- (int) runStep:   (int) externalinput: (double) actime: (int) stepno; // single step
- removeSynapsesAndTargets ; // remove all prior to setting them up: here, only targets

@end
