//
//  InputNeuron.m
//  Neuron1
//
//  Created by Leslie Smith on Sat Jun 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "InputNeuron.h"
#import "synapse.h"


@implementation InputNeuron

- init
	/* initialise on setup */
{
	[super init] ;
	PostSynaptic = [NSMutableArray arrayWithCapacity: MAXPOSTSYNAPSES] ;
	[PostSynaptic retain] ;
	return self ;
}

- (void)dealloc {
	[self removeSynapsesAndTargets] ;
	if (PostSynaptic != nil) [PostSynaptic release] ;
    [super dealloc];
}

- (int) isInputNeuron 
{
	return YES ;
}

- removeSynapsesAndTargets 
	// remove all the  targets prior to setting them all up
{
	if (PostSynaptic != nil) [PostSynaptic removeAllObjects] ;
	return self ;
}

- addTarget: Syn  // add a synapse to the set that this neuron innervates (is presynaptic)
{
	[PostSynaptic addObject: Syn] ;
	return self ;
}

- setTimeStep: (float) stepsize  /* set timestep */
/* must be after setting of refractory period */
{
	timestep = stepsize ;
	return self ;
}

- resetNeuron
{
	output = 0 ; 
	return self ;
}

- (int) getOutput   /* returns output */
{
	return output ;
}

- (float) getTimeStep 
{
	return timestep ;
}

- (int) runStep:   (int) externalinput: (double) actime: (int) stepno
// run a single step: simply make the output the (integer) external input
{
	int outvalue ;
	outvalue = externalinput ;
	output = outvalue ;
	if (outvalue == 1) // fires
		[self fire: actime: stepno] ;

	return outvalue ;
}

- fire : (double) actime : (int) stepno// action to take on firing at time actime
{
	synapse *ThisSynapse ;
	// notify target synapses if any that this neuron has fired
	if (PostSynaptic != nil)
	{
		NSEnumerator *enumerator = [PostSynaptic objectEnumerator];
		while (ThisSynapse = [enumerator nextObject]) {
			[ThisSynapse presynFires: actime: stepno] ;
		}
	}
	return self ;
}
	
@end
