//
//  SpikeArray.m
//  Neuron1
//
//  Created by Leslie Smith on 22/09/2004.
//  Copyright 2004 University of Stirling. All rights reserved.
//

#import "SpikeArray.h"


@implementation SpikeArray
- initWithSpikearrayAndNumSpikes: (spikearray) spikestobeheld numberofspikes: (int) nspikes 
{
	[super init] ;
	spikesheld = spikestobeheld ;
	numspikes = nspikes ;
	return self ;
}

- (id) initWithCoder: (NSCoder *) coder ;
{
	NSUInteger spikedatastructurelength, i ;
	NSUInteger *spdslngth ;
	spikearray spikestemp ;
	spdslngth = &spikedatastructurelength ;
	// dearchive both numspikes and spikesheld
	numspikes = [coder decodeIntForKey: @"numspikes"] ;
	// spikestemp = (spikearray) [coder decodeBytesForKey: @"spikesheld" returnedLength: &spikedatastructurelength] ;
	spikestemp = (spikearray) [coder decodeBytesForKey: @"spikesheld" returnedLength: spdslngth] ;

	if (spikedatastructurelength != (numspikes * sizeof(spiketype)))
		NSLog(@"SpikeArray:initWithCoder spikesheld returned length = %i differs from expected = %i\n", 
			  spikedatastructurelength, (numspikes * sizeof(spiketype))) ;
	// copy the bytes across
	// spikesheld = (spikearray)malloc(spikedatastructurelength) ;
	spikesheld = (spikearray)malloc(*spdslngth) ;
	for (i=0;i<numspikes;i++)
		spikesheld[i] = spikestemp[i] ;
	return self ;
}

- (void) encodeWithCoder: (NSCoder *) coder ;
{
	int spikedatastructurelength ;
	// archive both numspikes and spikesheld
	[coder encodeInt: numspikes forKey: @"numspikes"] ;
	spikedatastructurelength = numspikes * sizeof(spiketype) ;
	[coder encodeBytes: (uint8_t *) spikesheld length: spikedatastructurelength forKey: @"spikesheld"] ;
}

- (int) getNumspikes 
{
	return numspikes ;
}

- (spikearray) getInputSpikes 
{
	return spikesheld ;
}
@end
