//
//  Spikes.m
//  Neuron1
//
//  Created by Leslie Smith on 21/09/2004.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import "Spikes.h"


@implementation Spikes

- (id) initWithSpikeArrayAndParams: (SpikeArray *) SpikesForStoring params: (NSMutableDictionary *) GenParams 
{
	[super init] ;
	SpikesStored = SpikesForStoring ;
	GeneratingParams = GenParams ;
	return self ;
}

- (id) initWithCoder: (NSCoder *) coder 
{
	[self setSpikesArray: [coder decodeObjectForKey: @"spikeArray" ] ] ;
	[self setGeneratingParams:[ coder decodeObjectForKey:@"generatingParams"] ] ;
	return self ;
}

- (void) encodeWithCoder: (NSCoder *) coder 
{
	[coder encodeObject: SpikesStored forKey: @"spikeArray"] ;
	[coder encodeObject: GeneratingParams forKey: @"generatingParams"]  ;
}

- (void) setSpikesArray: (SpikeArray *) SpikeObject 
{
	SpikesStored = SpikeObject ;
	[SpikesStored retain] ;
}

- (SpikeArray *) returnSpikeArrayObject 
{
	return SpikesStored ;
}

- (void) setGeneratingParams: (NSMutableDictionary *) GenParams ;
{
	GeneratingParams = GenParams ;
	[GeneratingParams retain] ;
}
	
- (NSMutableDictionary *) getGeneratingParams ;
{
	return GeneratingParams ;
}

- (void) saveSpikesHumanReadable: (NSString *) FileName 
// write out the spikes in a human readable (and re-usable) format
{
	FILE *spikeoutput ;
	spikearray thespikes ;
	int spikeno ;
	// open file for writing
	spikeoutput = fopen([FileName UTF8String],"w") ;
	// write the initial part of the file
	fprintf(spikeoutput, "nspikes\t%i\n", [SpikesStored getNumspikes]) ;
	fprintf(spikeoutput, "spikes\n") ;
	thespikes = [SpikesStored getInputSpikes] ;
	// store all the spikes
	for (spikeno = 0; spikeno < [SpikesStored getNumspikes]; spikeno++)
	{
		fprintf(spikeoutput, "%i\t%f\n", thespikes[spikeno].neuron, thespikes[spikeno].timeofspike) ;
	}
	fclose(spikeoutput) ;
}
@end
