//
//  synapse.m
//  Neuron1
//
//  Created by Leslie Smith on Tue Jun 15 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "synapse.h"
// #import <CoreServices/fp.h>


@implementation synapse

- init
	/* initialise on setup */
{
	[super init] ;
	lastspiketime = -1 ; // show that no spikes have been received
	return self ;
}

- setWeight:  (float) w 
{
	weight = w ;
	return self ;
}

- setAlpha: (float) alph
{ 
	alpha = alph ;
	return self ;
}

- setSynapseType:  (int)s 
{
	synapsetype = s ;
	return self ;
}

- setPresynNeuron:  NNN 
{
	PresynNeuron = NNN ;
	return self ;
}

- setPostsynNeuron:  NNN 
{
	PostsynNeuron = NNN ;
	return self ;
}
	
- (float) getWeight
{
	return weight ;
}

- (float) getSynapseType 
{
	return synapsetype ;
}

- getPresynNeuron
{
	return PresynNeuron ;
}

- getPostsynNeuron
{
	return PostsynNeuron ;
}

- presynFires: (float) t_fire: (int) stepfire
// notification that presynaptic neuron has fired
{
	lastspiketime = t_fire ;
	lastspikestep = stepfire ;
	printf("%s%f%s","Synapse:presynFires spike at ", t_fire, "\n") ;
	return self ;
}

- computeSynapseEffects: (double) timestep: (double) microstep
{
	// compute the value of the alpha function for each microstep
	// then place these values into an array for use by getSynapticContribution
	// uses alpha function
	// (alpha * alpha) * t * exp(-alpha * (t)) ;
	int mlength;
	int i,j,start_accum, end_accum ;
	double total ;
	// calculate the alpha function for 10 * 1/alpha microsteps
	mlength = (int) floor((10*(1/alpha))/microstep) ;
	float marray[mlength] ;
	total = 0 ;
	for (i=0;i<mlength;i++)
	{
		marray[i] = (alpha * alpha) * (i * microstep) * exp(-alpha * (i * microstep)) ;
		total = total + marray[i] ;
		// printf("%f %s", exp(-alpha * (i * microstep)), "\n") ;
	}
	// now parcel them up for use by getSynapticContribution
	lengthalphaeffect = (int) ceil((float) mlength * (microstep/timestep)) ;
	if (lengthalphaeffect > MAXTIMESTEPEFFECT)
		printf("%s","synapse:computeSynapseEffects. Overlong effect of alpha function. Increase MAXTIMESTEPEFFECT \n");
	start_accum = 0 ;
	
	for (i=0;i<lengthalphaeffect;i++)
	{
		alphaarray[i] = 0 ;
		end_accum = (int)(round(i*(timestep/microstep))) ;
		for (j=start_accum;j<end_accum;j++)
			alphaarray[i] = alphaarray[i] + marray[j] ;
		start_accum = end_accum  ;
		alphaarray[i] = alphaarray[i]/total ;
	}
	
	// temp
	// for (i=0;i<lengthalphaeffect;i++)
	 // 	printf("%s%i%f%s", "alphaeffect ", i, alphaarray[i], "\n") ;
	return self ;
}

- (float) getSynapticContribution: (double) current_time: (int) stepno
{
	float contribution ;
	if (lastspiketime < 0) contribution = 0 ;
	else
	{
		if ((stepno - lastspikestep) < lengthalphaeffect)
			contribution = weight * alphaarray[stepno - lastspikestep] ;
	}
	return contribution;
}

@end
